#define MAX_LEN 10000000

#include <linux/gamma/libgamma.h>
#include <stdio.h>
#include <stdlib.h>
#include "measure_curva.h"  /* NPROVE, WARM_UP, mean_variance()... */

#define MASTER 0
#define PORT 1


unsigned char *data,*data1;
int len;


int main(int argc, char **argv) {

	int			me,i,j,k,status,responders;
	double			record_mm[NPROVE];
	double			mmm,Mmm,medmm,varmm,time_overhead;
	time_586		t_send_s,t_rec;

	typedef struct
	{ int x; double y; }	tr;
	tr			*total_record;


	responders = atoi(argv[1]);
	gamma_init(1+responders,argc,argv);
	me = gamma_my_node();

	/*  Alloc data space (+4096 to allow page alignment)  */
	data1 = (unsigned char *)malloc(4096+MAX_LEN*sizeof(unsigned char));
	/*  Align to page  */
	data = (unsigned char *)(((unsigned long)data1+4096) & (~4095));

	total_record = (tr *)malloc(10000*sizeof(tr));

	/*  Pin communication data structures in RAM.  */
	gamma_mlock(data,MAX_LEN);

	/*  Set up ports */
	if ( me == MASTER ) {
/*
 *  PING: send OK to all responders, get "len/responders" bytes from all of
 *  them
 */
		for ( j=1; j<=responders; j++ )
			gamma_set_passive_port(
				j,
				j,gamma_my_par_pid(),PORT,
				PORT,GO_BACK,data,len);
	} else {
/*
 *  responders: wait for OK from PING, then send it "len/responders" bytes
 */
		gamma_set_passive_port(
			PORT,
			MASTER,gamma_my_par_pid(),me,
			PORT,GO_BACK,data,len);

	}
	gamma_sync();

/*  compute the gamma_time() overhead  */
	for ( i=0; i<NPROVE; i++ ) {
		gamma_time(t_send_s);
 		gamma_time(t_rec);
		record_mm[i] = gamma_time_diff(t_rec,t_send_s);
	}
	mean_variance(record_mm,&time_overhead,&Mmm,&medmm,&varmm);

/*  Init the message to be exchanged.  */
	for ( j=0; j<len; j++ )
		if ( me == MASTER )
			data[j] = (unsigned char)j;
		else
			data[j] = (unsigned char)0;

	k = 0;
//	len = 0;
{
int peppe=1;
for (;;) {
	len = 299346;
//	while ( len <= MAX_LEN ) {
if (!me) fprintf(stderr,"ciao\n");
	while ( len <= 299346) {

		if ( me == MASTER ) {
/*
 *  PING: send OK to all responders, get "len/responders" bytes from all of
 *  them
 */
			for ( i=0; i<NPROVE; i++ ) {

				gamma_time(t_send_s);
				for ( j=1; j<=responders; j++ )
					gamma_send_flowctl(j,NULL,0);
				status = gamma_wait(PORT,responders);
 				gamma_time(t_rec);

				if ( status ) {
					fprintf(stderr,"PING:  ERROR\n");
					free(data1);
					gamma_exit();
					exit(-1);
				}

				record_mm[i] = gamma_time_diff(t_rec,t_send_s)
						-time_overhead;

			}

			total_record[k].x = len;
			mean_variance(record_mm,&mmm,&Mmm,&medmm,&varmm);
			total_record[k].y = len ? len/medmm : medmm;

		} else {
/*
 *  responders: wait for OK from PING, then send it "len/responders" bytes
 */
			for ( i=0; i<NPROVE; i++ ) {
				if ( !gamma_wait(PORT,1) ) {
					gamma_send_flowctl(PORT,data,
							len/responders);
					continue;
				}
				fprintf(stderr,"PONG:  ERROR\n");
				free(data1);
				gamma_exit();
				exit(-1);
			}

		}

		k++;

//		if ( len<16384 ) len += 4;
//		else if ( len<1048576 ) len += 4096;
//		else len += 40960;
		len += 1;

	}
if (peppe--) continue;
break;
}
}

	if ( me == MASTER ) {
		for ( i=0; i<k; i++ )
			printf("%d %g\n",total_record[i].x,total_record[i].y);
		fflush(stdout);
	}
	free(data1);
	gamma_exit();
	return 0;

}
