#include <linux/autoconf.h>	/*  "CONFIG_SMP"                */
#include <linux/linkage.h>      /*  "ALIGN", "ENTRY(name)"      */
#include <asm/segment_32.h>	/*  "__KERNEL_PERCPU"           */

/*
 * Register setup:
 * eax  system call number
 * ebx  arg1
 * ecx  arg2
 * edx  arg3
 * esi  arg4
 * edi  arg5
 */

ENTRY(gamma_system_call)
        cld
	pushl %fs
        pushl %ebp
        pushl %edi
        pushl %esi
        pushl %edx
        pushl %ecx
        pushl %ebx
	movl $(__KERNEL_PERCPU), %edx
	movl %edx, %fs
	sti
        call *gamma_sys_call_table(,%eax,4)
	cli
        popl %ebx
        popl %ecx
        popl %edx
        popl %esi
        popl %edi
        popl %ebp
	popl %fs
        iret
	ALIGN

.data
ENTRY(gamma_sys_call_table)
        .long sys_gamma_init_part1	/*  0  */
        .long sys_gamma_connect_port	/*  1  */
        .long sys_gamma_send		/*  2  */
        .long sys_gamma_exit		/*  3  */
        .long sys_gamma_vm_create	/*  4  */
        .long sys_gamma_vm_abort	/*  5  */
        .long sys_gamma_register	/*  6  */
        .long sys_gamma_getconfig	/*  7  */
        .long sys_gamma_poll		/*  8  */
        .long sys_gamma_timers		/*  9  */
        .long sys_gamma_mlock		/* 10  */
        .long sys_gamma_munlock		/* 11  */
        .long sys_gamma_munlockall	/* 12  */
        .long sys_gamma_init_part2	/* 13  */
        .long sys_gamma_send_flowctl	/* 14  */
        .long sys_gamma_send_2p_flowctl	/* 15  */
        .long sys_gamma_send_2p		/* 16  */
        .long sys_gamma_printk		/* 17  */
        .long sys_gamma_poll_intranode	/* 18  */
        .long sys_gamma_init_part3	/* 19  */
        .long sys_gamma_suspend_irq	/* 20  */
        .long sys_gamma_resume_irq	/* 21  */
        .long sys_gamma_isend		/* 22  */
        .long sys_gamma_isend_flowctl	/* 23  */
        .long sys_gamma_isend_2p	/* 24  */
        .long sys_gamma_isend_2p_flowctl/* 25  */
        .long sys_gamma_wsend		/* 26  */
        .long sys_gamma_tsend		/* 27  */
        .long sys_gamma_vm_create_bykey	/* 28  */
        .long sys_gamma_vm_wish		/* 29  */
        .long sys_gamma_vm_getinfo	/* 30  */
        .long sys_gamma_register_nospawn/* 31  */
        .long sys_gamma_setcredit	/* 32  */
        .long sys_gamma_resetcredit	/* 33  */
        .long sys_gamma_getcredit	/* 34  */
        .long sys_gamma_setmaxpolls	/* 35  */
        .long sys_gamma_resetmaxpolls	/* 36  */
        .long sys_gamma_getmaxpolls	/* 37  */
        .long sys_gamma_poll_nowait	/* 38  */
        .long sys_gamma_post_recv	/* 39  */
        .long sys_gamma_switch_to_buffer/* 40  */
        .long sys_gamma_recvptr		/* 41  */
        .long sys_gamma_getkey		/* 42  */
